diff --git a/lib/hive/claude_completion_fallback.rb b/lib/hive/claude_completion_fallback.rb
new file mode 100644
index 00000000..90e2b58f
--- /dev/null
+++ b/lib/hive/claude_completion_fallback.rb
@@ -0,0 +1,123 @@
+# frozen_string_literal: true
+
+require "digest"
+require "hive/events"
+
+module Hive
+  # A deliberately small, immutable control-plane decision for a Claude tmux
+  # turn whose Stop hook did not publish `.done`. It never infers semantic
+  # success from the terminal UI: callers must supply a phase-specific probe.
+  module ClaudeCompletionFallback
+    Evidence = Data.define(
+      :phase,
+      :sentinel_path,
+      :missing_signal_reason,
+      :session_name,
+      :pane_pid,
+      :sentinel_missing,
+      :work_started,
+      :returned_to_idle,
+      :stable_idle,
+      :session_readable,
+      :no_failure_output,
+      :no_failure_result,
+      :probe_accepted,
+      :exit_status,
+      :probe
+    )
+
+    Decision = Data.define(:evidence, :rejections) do
+      def accepted?
+        rejections.empty?
+      end
+
+      def to_h
+        {
+          phase: evidence.phase,
+          sentinel_path: evidence.sentinel_path,
+          missing_signal_reason: evidence.missing_signal_reason,
+          session_name: evidence.session_name,
+          pane_pid: evidence.pane_pid,
+          artifacts_checked: evidence.probe.is_a?(Hash) ? evidence.probe[:artifacts_checked] : nil,
+          commit_range: evidence.probe.is_a?(Hash) ? evidence.probe[:commit_range] : nil,
+          no_change_rationale: evidence.probe.is_a?(Hash) ? evidence.probe[:no_change_rationale] : nil,
+          rejections: rejections
+        }
+      end
+    end
+
+    module_function
+
+    AUDIT_VALUE_BYTES = {
+      level: 8,
+      phase: 32,
+      pass: 8,
+      task_slug: 80,
+      session: 80,
+      pid: 20,
+      sentinel: 120,
+      missing_signal_reason: 64,
+      artifacts: 180,
+      commit_range: 96,
+      no_change_rationale: 140
+    }.freeze
+
+    # Keep the generic predicate centralized so every tmux consumer gets the
+    # same fail-closed behavior. A caller without a semantic probe leaves
+    # `probe_accepted` false and therefore cannot use fallback completion.
+    def evaluate(evidence)
+      required = {
+        sentinel_missing: evidence.sentinel_missing,
+        work_started: evidence.work_started,
+        returned_to_idle: evidence.returned_to_idle,
+        stable_idle: evidence.stable_idle,
+        session_readable: evidence.session_readable,
+        no_failure_output: evidence.no_failure_output,
+        no_failure_result: evidence.no_failure_result,
+        probe_accepted: evidence.probe_accepted
+      }
+      rejected = required.filter_map { |name, value| name unless value }
+      rejected << :exit_status_zero unless evidence.exit_status.is_a?(Integer) && evidence.exit_status.zero?
+      Decision.new(evidence, rejected.freeze)
+    end
+
+    # Event records have a stable schema consumed by status/TUI tooling. Keep
+    # fallback detail in one bounded key/value message so every launcher mode
+    # can emit the required WARN audit before returning an accepted envelope.
+    def audit_message(task_slug:, pass:, fields:)
+      formatted_pass = pass.is_a?(Integer) ? format("%02d", pass) : pass.to_s
+      formatted_pass = "unknown" if formatted_pass.empty?
+      values = {
+        level: "WARN",
+        phase: fields[:phase] || "unknown",
+        pass: formatted_pass,
+        task_slug: task_slug,
+        session: fields[:session_name] || "unknown",
+        pid: fields[:pane_pid] || "unknown",
+        sentinel: fields[:sentinel_path] || "unknown",
+        missing_signal_reason: fields[:missing_signal_reason] || "unknown",
+        artifacts: Array(fields[:artifacts_checked]).join(","),
+        commit_range: fields[:commit_range] || "",
+        no_change_rationale: fields[:no_change_rationale] || ""
+      }
+      message = values.map do |key, value|
+        "#{key}=#{audit_value(value, max_bytes: AUDIT_VALUE_BYTES.fetch(key))}"
+      end.join(" ")
+      if message.bytesize > Hive::Events::MAX_MESSAGE_BYTES
+        raise Hive::Error, "claude completion fallback audit message exceeds event limit"
+      end
+
+      message
+    end
+
+    def audit_value(value, max_bytes: 240)
+      sanitized = value.to_s.gsub(/[\r\n\s]+/, "_").gsub(/[^A-Za-z0-9_.,:;=\/-]/, "?")
+      return sanitized if sanitized.bytesize <= max_bytes
+
+      digest = ::Digest::SHA256.hexdigest(sanitized).slice(0, 12)
+      suffix = "~sha256=#{digest}"
+      prefix = sanitized.byteslice(0, max_bytes - suffix.bytesize).to_s
+      "#{prefix}#{suffix}"
+    end
+  end
+end
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a41..1e8a60cc 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -5,7 +5,9 @@ require "time"
 
 require "hive/agent_profiles"
 require "hive/agent_limit"
+require "hive/claude_completion_fallback"
 require "hive/config"
+require "hive/events"
 require "hive/lock"
 require "hive/markers"
 require "hive/permission_scope"
@@ -87,6 +89,11 @@ module Hive
     # `.last(TAIL_LINES)` below is a no-op only while the two match. Narrowing
     # one without the other would silently shrink the scan vs. context window.
     CLAUDE_PROMPT_TAIL_LINES = 12
+    # These are intentionally narrow operational failure hints, distinct from
+    # ordinary prose in a completed response. A detected provider limit is
+    # handled by AgentLimit; these catch the explicit crash/fatal panes that
+    # must never become fallback candidates.
+    CLAUDE_COMPLETION_FAILURE_LINE = /(?:\A|\n)\s*(?:fatal error|claude crashed|unexpected error)\b/i.freeze
     # Allowed-tool sets shared by every stage that spawns Claude. Keeping
     # them as constants means a policy change lands in one place; previous
     # PRs inlined the string literal across 11 sites and silently drifted
@@ -126,9 +133,13 @@ module Hive
       /\Atmux \S+ below minimum/
     ].freeze
 
-    SessionHandle = Struct.new(:task, :runner, :reestablish, keyword_init: true) do
+    SessionHandle = Struct.new(
+      :task, :runner, :reestablish, :before_completion_probe,
+      keyword_init: true
+    ) do
       def send_and_wait!(prompt:, expected_output: nil, timeout_sec:,
-                         status_mode: nil, log_label: nil, deadline: nil)
+                         status_mode: nil, log_label: nil, deadline: nil,
+                         completion_probe: nil, completion_phase: nil)
         Hive::ClaudeLauncher.send_prompt_and_wait!(
           task: task,
           runner: runner,
@@ -138,7 +149,10 @@ module Hive
           status_mode: status_mode,
           log_label: log_label,
           deadline: deadline,
-          reestablish: reestablish
+          reestablish: reestablish,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase,
+          before_completion_probe: before_completion_probe
         )
       end
     end
@@ -151,7 +165,8 @@ module Hive
                 allowed_tools: nil,
                 disallowed_tools: nil,
                 permission_mode: nil, mcp_config_path: nil,
-                strict_mcp_config: false)
+                strict_mcp_config: false,
+                completion_probe: nil, completion_phase: nil)
       profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
       ensure_claude_profile!(profile)
       permission_mode ||= Hive::Config.claude_permission_mode(cfg)
@@ -202,7 +217,9 @@ module Hive
           expected_output: expected_output,
           timeout_sec: timeout_sec,
           status_mode: status_mode || profile.status_detection_mode,
-          log_label: log_label
+          log_label: log_label,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase
         )
       end
       result
@@ -228,6 +245,16 @@ module Hive
       preflight!(profile, runner)
 
       settings_paths = []
+      restore_settings = lambda do
+        paths = Array(settings_paths).dup
+        paths.each do |path|
+          safe_with_log(task, "cleanup_scratch") { cleanup_scratch(path) }
+        end
+        # cleanup_scratch is not idempotent for a restored project-owned
+        # file: a second call would see no backup and delete the restored
+        # settings. Remove attempted paths before any later cleanup pass.
+        settings_paths -= paths
+      end
       begin
         # Install the Stop hook under task.folder (orchestrator-owned)
         # AND the launch cwd. Claude resolves `.claude/settings.json`
@@ -237,7 +264,9 @@ module Hive
         # until timeout.
         settings_paths = Array(Hive::StopHookInstaller.install(
           stage_dir: task.folder,
-          extra_dirs: [ cwd ]
+          extra_dirs: [ cwd ],
+          done_path: done_path(task),
+          result_path: result_path(task)
         ))
         launch_command = wrapper_command(
           cwd: cwd,
@@ -261,7 +290,12 @@ module Hive
         end
         establish.call
         prepare_claude_session!(runner)
-        yield SessionHandle.new(task: task, runner: runner, reestablish: establish)
+        yield SessionHandle.new(
+          task: task,
+          runner: runner,
+          reestablish: establish,
+          before_completion_probe: restore_settings
+        )
       ensure
         # Send `/quit` to claude inside the pane and give it a brief
         # window to exit cleanly before SIGKILL'ing the tmux session.
@@ -272,16 +306,16 @@ module Hive
         safe_with_log(task, "shutdown_claude") { shutdown_claude(runner) }
         safe_with_log(task, "kill_session") { runner.kill_session if runner }
         safe_with_log(task, "sweep_orphan_processes") { sweep_orphan_processes(task) }
-        Array(settings_paths).each do |path|
-          safe_with_log(task, "cleanup_scratch") { cleanup_scratch(path) }
-        end
-        safe_with_log(task, "cleanup_done") { cleanup_done(task) }
+        restore_settings.call
+        safe_with_log(task, "reset_signal_files") { reset_signal_files(task) }
       end
     end
 
     def send_prompt_and_wait!(task:, runner:, prompt:, timeout_sec:,
                               expected_output: nil, status_mode: nil,
-                              log_label: nil, deadline: nil, reestablish: nil)
+                              log_label: nil, deadline: nil, reestablish: nil,
+                              completion_probe: nil, completion_phase: nil,
+                              before_completion_probe: nil)
       reset_signal_files(task)
       cleanup_expected_output(expected_output)
       reestablish_dead_session!(runner, reestablish)
@@ -305,7 +339,12 @@ module Hive
                           started: Time.now.utc.iso8601)
       end
       runner.send_prompt(prompt)
-      result = wait_for_status(task, runner, effective_timeout_sec, status_mode, expected_output, log_label)
+      result = wait_for_status(
+        task, runner, effective_timeout_sec, status_mode, expected_output, log_label,
+        completion_probe: completion_probe,
+        completion_phase: completion_phase,
+        before_completion_probe: before_completion_probe
+      )
       # Headless launches drop a `<log_label>-<ts>.log` under
       # `task.log_dir`; tmux launches need the same shared log path so
       # downstream Claude-driven stages can find per-invocation output.
@@ -364,15 +403,33 @@ module Hive
       nil
     end
 
-    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label)
+    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label,
+                        completion_probe: nil, completion_phase: nil,
+                        before_completion_probe: nil)
       case status_mode || :state_file_marker
       when :state_file_marker
-        marker = wait_for_terminal_marker(task, runner, timeout)
-        { status: marker.name, log_label: log_label }
+        wait_for_terminal_marker(
+          task, runner, timeout,
+          log_label: log_label,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase,
+          before_completion_probe: before_completion_probe,
+          result_envelope: true
+        )
       when :output_file_exists
-        wait_for_expected_output(task, runner, timeout, expected_output, log_label)
+        wait_for_expected_output(
+          task, runner, timeout, expected_output, log_label,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase,
+          before_completion_probe: before_completion_probe
+        )
       when :exit_code_only
-        wait_for_done_signal(task, runner, timeout, log_label)
+        wait_for_done_signal(
+          task, runner, timeout, log_label,
+          completion_probe: completion_probe,
+          completion_phase: completion_phase,
+          before_completion_probe: before_completion_probe
+        )
       else
         raise ArgumentError, "unknown status_mode: #{status_mode.inspect}"
       end
@@ -417,7 +474,8 @@ module Hive
           # SCRUBBED_CHILD_ENV mirrors this for the headless path — keep the
           # three sibling scrub sites in step.
           "HIVE_SCREENOTE_BASE_URL" => "",
-          "HIVE_TASK_STAGE_DIR" => task.folder
+          "HIVE_TASK_STAGE_DIR" => task.folder,
+          "HIVE_TMUX_SESSION" => session_name
         },
         tmux_bin: tmux_bin,
         socket_name: ENV["HIVE_TMUX_SOCKET"]
@@ -552,8 +610,13 @@ module Hive
     # single-shot path (`reestablish` nil), preserving the hard-fail there.
     def reestablish_dead_session!(runner, reestablish)
       return unless reestablish
-      return unless runner.respond_to?(:session_exists?) && !runner.session_exists?
+      return unless runner.respond_to?(:session_exists?)
+
+      session_exists = runner.session_exists?
+      retained_dead_pane = session_exists && runner.respond_to?(:pane_dead?) && runner.pane_dead?
+      return if session_exists && !retained_dead_pane
 
+      runner.kill_session if retained_dead_pane && runner.respond_to?(:kill_session)
       reestablish.call
     end
 
@@ -669,27 +732,118 @@ module Hive
       current_lines.reject(&:empty?).last(CLAUDE_PROMPT_CONTEXT_LINES).join("\n")
     end
 
-    def wait_for_terminal_marker(task, runner, timeout)
+    def wait_for_terminal_marker(task, runner, timeout, log_label: nil,
+                                 completion_probe: nil, completion_phase: nil,
+                                 before_completion_probe: nil,
+                                 result_envelope: false)
       deadline = Time.now + timeout
-      last_sentinel_check = Time.at(0)
+      lifecycle = completion_lifecycle
       loop do
+        pane_tail, pane_error = capture_completion_tail(runner)
+        if pane_error
+          gone = tmux_session_gone_marker(task, runner)
+          return terminal_marker_result(gone, log_label, result_envelope) if
+            gone&.attrs&.fetch("reason", nil) == "tmux_session_terminated"
+
+          lifecycle[:session_readable] = false
+          Hive::Markers.set(task.state_file, :error,
+                            reason: "tmux_pane_unreadable", message: pane_error)
+          return terminal_marker_result(
+            Hive::Markers.current(task.state_file), log_label, result_envelope,
+            fallback_decision: fallback_decision(
+              task, runner, lifecycle, completion_phase, nil
+            )
+          )
+        end
+        unless runner.respond_to?(:capture_pane_tail)
+          gone = tmux_session_gone_marker(task, runner)
+          return terminal_marker_result(gone, log_label, result_envelope) if gone
+        end
+
         if File.exist?(done_path(task))
           marker = Hive::Markers.current(task.state_file)
-          return marker if terminal_marker?(marker)
+          signal = result_json_completion(task, log_label, success_status: marker.name)
+          if signal[:status] == :error
+            Hive::Markers.set(task.state_file, :error,
+                              reason: "invalid_stop_hook_result",
+                              message: signal[:error_message] || "terminal marker missing after Stop signal")
+            marker = Hive::Markers.current(task.state_file)
+            return terminal_marker_result(
+              marker, log_label, result_envelope, **signal.except(:status, :log_label)
+            )
+          end
+          if signal[:status] == marker.name && terminal_marker?(marker)
+            return terminal_marker_result(
+              marker, log_label, result_envelope, **signal.except(:status, :log_label)
+            )
+          end
 
+          # Stop can wake while the agent-owned marker is still nonterminal.
+          # Clear only the wake-up sentinel and keep waiting for the documented
+          # terminal marker instead of converting a valid intermediate Stop
+          # callback into a hard launcher error.
           cleanup_done(task)
         end
 
-        if Time.now - last_sentinel_check >= sentinel_poll_interval
-          last_sentinel_check = Time.now
-          gone = tmux_session_gone_marker(task, runner)
-          return gone if gone
-
-          limit = limits_reached_marker(task, runner)
-          return limit if limit
+        if (failure = completion_failure_result(
+          task, runner, lifecycle, completion_phase, pane_tail
+        ))
+          if failure[:limit_text]
+            Hive::Markers.set(task.state_file, :error,
+                              reason: "limits_reached",
+                              message: failure.fetch(:error_message),
+                              retry_after: Hive::AgentLimit.retry_after)
+          else
+            Hive::Markers.set(task.state_file, :error,
+                              reason: "claude_completion_failure",
+                              message: failure.fetch(:error_message))
+          end
+          return terminal_marker_result(
+            Hive::Markers.current(task.state_file), log_label, result_envelope,
+            **failure.reject { |key, _| key == :status }
+          )
+        end
 
-          marker = marker_from_sentinel_tail(task, runner)
-          return marker if marker
+        update_completion_lifecycle!(lifecycle, pane_tail)
+        marker = terminal_marker_from_pane(task, pane_tail)
+        if marker&.name == :error
+          return terminal_marker_result(marker, log_label, result_envelope)
+        end
+        if marker && lifecycle[:stable_idle]
+          built_in_probe = lambda do |**|
+            {
+              accepted: true,
+              artifacts_checked: [ task.state_file ],
+              terminal_marker: marker.name
+            }
+          end
+          probe = combine_completion_probes(built_in_probe, completion_probe)
+          fallback = complete_fallback_attempt(
+            task: task,
+            runner: runner,
+            deadline: deadline,
+            lifecycle: lifecycle,
+            completion_probe: probe,
+            completion_phase: completion_phase || "state_file_marker",
+            before_completion_probe: before_completion_probe,
+            log_label: log_label,
+            success_status: marker.name,
+            normal_completion: lambda {
+              next nil unless File.exist?(done_path(task))
+
+              current = Hive::Markers.current(task.state_file)
+              next nil unless terminal_marker?(current)
+
+              result_json_completion(task, log_label, success_status: current.name)
+            }
+          )
+          return fallback if result_envelope
+          return marker if fallback[:status] == marker.name
+
+          Hive::Markers.set(task.state_file, :error,
+                            reason: "stop_hook_sentinel_missing",
+                            message: fallback.fetch(:error_message))
+          return Hive::Markers.current(task.state_file)
         end
 
         if Time.now >= deadline
@@ -701,17 +855,31 @@ module Hive
           # `reason="timeout"` would mask the real root cause. Preserve
           # the existing attribution and bail.
           if existing.name == :error && existing.attrs["reason"] == "tmux_pane_unreadable"
-            return existing
+            return terminal_marker_result(existing, log_label, result_envelope)
           end
 
           Hive::Markers.set(task.state_file, :error, reason: "timeout", timeout_sec: timeout)
-          return Hive::Markers.current(task.state_file)
+          marker = Hive::Markers.current(task.state_file)
+          decision = fallback_decision(
+            task, runner, lifecycle, completion_phase, nil
+          )
+          return terminal_marker_result(
+            marker, log_label, result_envelope,
+            error_message: "claude stop hook did not signal completion",
+            fallback_decision: decision
+          )
         end
 
         sleep [ poll_interval, deadline - Time.now ].min
       end
     end
 
+    def terminal_marker_result(marker, log_label, result_envelope, **fields)
+      return marker unless result_envelope
+
+      { status: marker.name, log_label: log_label, **fields }
+    end
+
     def terminal_marker?(marker)
       TERMINAL_MARKERS.include?(marker.name)
     end
@@ -732,25 +900,9 @@ module Hive
       Hive::Markers.current(task.state_file)
     end
 
-    def limits_reached_marker(task, runner)
-      pane = capture_limit_tail(runner)
-      limit_line = Hive::AgentLimit.live_limit_line(pane)
-      return nil unless limit_line
-
-      Hive::Markers.set(task.state_file, :error,
-                        reason: "limits_reached",
-                        message: Hive::AgentLimit.error_message(limit_line, agent: "claude"),
-                        retry_after: Hive::AgentLimit.retry_after)
-      Hive::Markers.current(task.state_file)
-    end
-
     def marker_from_sentinel_tail(task, runner)
-      marker = Hive::Markers.current(task.state_file)
-      return nil unless terminal_marker?(marker)
-
       pane = runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES)
-      names = pane.scan(Hive::Markers::MARKER_RE).map { |name, _| name.downcase.to_sym }
-      names.include?(marker.name) ? marker : nil
+      terminal_marker_from_pane(task, pane)
     rescue Hive::TmuxError => e
       # A persistent tmux failure mid-wait used to silently roll into
       # the outer timeout and surface as `:error reason="timeout"`.
@@ -763,57 +915,88 @@ module Hive
       nil
     end
 
-    def wait_for_expected_output(task, runner, timeout, expected_output, log_label)
+    def terminal_marker_from_pane(task, pane)
+      names = pane.scan(Hive::Markers::MARKER_RE).map { |name, _| name.downcase.to_sym }
+      return nil if names.empty?
+
+      marker = Hive::Markers.current(task.state_file)
+      return nil unless terminal_marker?(marker)
+
+      names.include?(marker.name) ? marker : nil
+    end
+
+    def wait_for_expected_output(task, runner, timeout, expected_output, log_label,
+                                 completion_probe: nil, completion_phase: nil,
+                                 before_completion_probe: nil)
       deadline = Time.now + timeout
-      tmux_error_streak = 0
-      last_tmux_error_msg = nil
+      lifecycle = completion_lifecycle
       loop do
         output_available = expected_output_available?(expected_output)
-        pane_tail = capture_limit_tail(runner)
-        if (limit_line = Hive::AgentLimit.live_limit_line(pane_tail))
+        pane_tail, pane_error = capture_completion_tail(runner)
+        if pane_error
+          lifecycle[:session_readable] = false
           return {
             status: :error,
-            limit_text: limit_line,
-            error_message: Hive::AgentLimit.error_message(limit_line, agent: "claude")
+            error_message: "tmux_pane_unreadable: #{pane_error}",
+            fallback_decision: fallback_decision(
+              task, runner, lifecycle, completion_phase, nil
+            )
           }
         end
+        if File.exist?(done_path(task))
+          return missing_output_result(expected_output) unless output_available
 
+          return result_json_completion(task, log_label)
+        end
+        if (failure = completion_failure_result(
+          task, runner, lifecycle, completion_phase, pane_tail
+        ))
+          return failure
+        end
         unless expected_output_session_alive?(runner)
-          return { status: :ok, log_label: log_label } if output_available && File.exist?(done_path(task))
-
           return {
             status: :error,
             error_message: "tmux_session_terminated before writing expected output file: #{expected_output}"
           }
         end
 
-        if output_available
-          return { status: :ok, log_label: log_label } if File.exist?(done_path(task))
-
-          begin
-            pane = runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES)
-            tmux_error_streak = 0
-            return { status: :ok, log_label: log_label } if claude_ready_prompt?(pane)
-          rescue Hive::TmuxError => e
-            tmux_error_streak += 1
-            last_tmux_error_msg = e.message
-            # After a handful of consecutive failures, the pane is
-            # demonstrably unreachable; bail with the real cause
-            # instead of polling silently to deadline and reporting
-            # a misleading "expected output file missing" timeout.
-            if tmux_error_streak >= 3
-              return {
-                status: :error,
-                error_message: "tmux_pane_unreadable: #{last_tmux_error_msg}"
-              }
+        update_completion_lifecycle!(lifecycle, pane_tail)
+        if output_available && lifecycle[:stable_idle]
+          built_in_probe = lambda do |**|
+            if expected_output_available?(expected_output)
+              { accepted: true, artifacts_checked: [ expected_output ] }
+            else
+              { accepted: false, rejection_reason: "expected output missing or empty" }
             end
           end
+          probe = combine_completion_probes(built_in_probe, completion_probe)
+          return complete_fallback_attempt(
+            task: task,
+            runner: runner,
+            deadline: deadline,
+            lifecycle: lifecycle,
+            completion_probe: probe,
+            completion_phase: completion_phase || "output_file_exists",
+            before_completion_probe: before_completion_probe,
+            log_label: log_label,
+            success_status: :ok,
+            normal_completion: lambda {
+              next nil unless File.exist?(done_path(task))
+              next missing_output_result(expected_output) unless expected_output_available?(expected_output)
+
+              result_json_completion(task, log_label)
+            }
+          )
         end
 
         if Time.now >= deadline
+          decision = fallback_decision(
+            task, runner, lifecycle, completion_phase, nil
+          )
           return {
             status: :timeout,
-            error_message: "expected output file missing or empty: #{expected_output}"
+            error_message: "expected output file missing or empty: #{expected_output}",
+            fallback_decision: decision
           }
         end
 
@@ -821,6 +1004,13 @@ module Hive
       end
     end
 
+    def missing_output_result(expected_output)
+      {
+        status: :error,
+        error_message: "expected output file missing or empty: #{expected_output}"
+      }
+    end
+
     def expected_output_available?(expected_output)
       File.exist?(expected_output.to_s) && File.size(expected_output.to_s).positive?
     end
